import * as Vue from "vue";
import VueClassComponent from "vue-class-component";
/**
 * decorator of a prop
 * @param  {PropOption}        options the option for the prop
 * @return {PropertyDecorator}         PropertyDecorator
 */
export declare function prop(options: (Vue.PropOptions | {
    new (...args: any[]): any;
})): PropertyDecorator;
/**
 * decorator of a watch function
 * @param  {string}            path the path or the expression to observe
 * @param  {WatchOption}       WatchOption
 * @return {MethodDecorator}      MethodDecorator
 */
export declare function watch(path: string, options?: Vue.WatchOptions): MethodDecorator;
export declare const Component: typeof VueClassComponent;
