/* vue-property-decorator verson 3.2.1 MIT LICENSE copyright 2016 kaorun343 */
"use strict";
var vue_class_component_1 = require("vue-class-component");
/**
 * decorator of a prop
 * @param  {PropOption}        options the option for the prop
 * @return {PropertyDecorator}         PropertyDecorator
 */
function prop(options) {
    return vue_class_component_1.createDecorator(function (componentOptions, key) {
        (componentOptions.props || (componentOptions.props = {}))[key] = options;
    });
}
exports.prop = prop;
/**
 * decorator of a watch function
 * @param  {string}            path the path or the expression to observe
 * @param  {WatchOption}       WatchOption
 * @return {MethodDecorator}      MethodDecorator
 */
function watch(path, options) {
    if (options === void 0) { options = {}; }
    var _a = options.deep, deep = _a === void 0 ? false : _a, _b = options.immediate, immediate = _b === void 0 ? false : _b;
    return vue_class_component_1.createDecorator(function (componentOptions, handler) {
        if (typeof componentOptions.watch !== 'object') {
            componentOptions.watch = Object.create(null);
        }
        componentOptions.watch[path] = { handler: handler, deep: deep, immediate: immediate };
    });
}
exports.watch = watch;
exports.Component = vue_class_component_1.default;
